//////////////////////////////////////////////////////////////         
//      $Id: findf.h,v 1.7 2000/05/02 15:01:38 toivo Exp $ 
//
// Author: Toivo Pedaste
//
#ifndef FINDF_H
#define FINDF_H

#include "../config.h"

// Standard Headers
#include <stdio.h>

// Qt Headers
#include <qdir.h>
#include <qwidget.h>
#include <qframe.h>
#include <qlabel.h>
#include <qfiledlg.h> 
#include <qgrpbox.h> 
#include <qchkbox.h>
#include <qlayout.h> 

// KDE headers
#include <kapp.h>
#include <kmenubar.h>
#include <ktmainwindow.h> 
#include <klistview.h> 

class FindF : public QDialog
{
  Q_OBJECT

public:

  FindF ( QWidget *parent = 0, const char *name=0);
  ~FindF(); 
  void resizeEvent(QResizeEvent *);
  void dropEvent(QDropEvent *);

private:
  void doFind(const QString &str);
  // Do the actual search

  QPushButton *ok, *cancel;
  QGroupBox *frame1;
  QLineEdit *value;
  QListView *tab;
  QVBoxLayout* vl;
  QVBoxLayout* vtop, vf;
    
  QHBoxLayout* hb;

signals:
    void findf_signal();
    void findf_done_signal();

public slots:
  void done_slot();
  void ok_slot();
  void search(QListViewItem *);

};
#endif
